<template>
  <rui-empty v-if="!resourceInteractionsGroup" :content="$t('js.resource_interaction.list.no_group_specified')" inline />
  <div v-else>
    <div class="-grid-3 -gap">
      <section>
        <h3>{{ $t('js.resource_interaction.list.positive_interactions') }}</h3>
        <rui-empty v-if="positiveInteractions.length === 0" :content="$t('js.resource_interaction.list.no_known_interactions')" inline />
        <gpa-resource-interactions-list-entry v-for="resourceInteraction in positiveInteractions"
                                              :key="resourceInteraction.id"
                                              :editable="editable"
                                              :for-group="resourceInteractionsGroup"
                                              :resource-interaction="resourceInteraction" />
      </section>

      <section>
        <h3>{{ $t('js.resource_interaction.list.neutral_interactions') }}</h3>
        <rui-empty v-if="neutralInteractions.length === 0" :content="$t('js.resource_interaction.list.no_known_interactions')" inline />
        <gpa-resource-interactions-list-entry v-for="resourceInteraction in neutralInteractions"
                                              :key="resourceInteraction.id"
                                              :editable="editable"
                                              :for-group="resourceInteractionsGroup"
                                              :resource-interaction="resourceInteraction" />
      </section>

      <section>
        <h3>{{ $t('js.resource_interaction.list.negative_interactions') }}</h3>
        <rui-empty v-if="negativeInteractions.length === 0" :content="$t('js.resource_interaction.list.no_known_interactions')" inline />
        <gpa-resource-interactions-list-entry v-for="resourceInteraction in negativeInteractions"
                                              :key="resourceInteraction.id"
                                              :editable="editable"
                                              :for-group="resourceInteractionsGroup"
                                              :resource-interaction="resourceInteraction" />
      </section>
    </div>
  </div>
</template>

<script>
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'

import ResourceInteractionsGroup from '../../../../classes/models/ResourceInteractionsGroup'
import GpaResourceInteractionsListEntry from './_ListEntry.vue'

export default {
  name: 'GpaResourceInteractionsList',
  components: { RuiEmpty, GpaResourceInteractionsListEntry },
  props: {
    resourceInteractionsGroup: { required: false, type: ResourceInteractionsGroup, default: null },
    editable: { required: false, type: Boolean, default: false },
  },
  computed: {
    positiveInteractions () {
      if (!this.$props.resourceInteractionsGroup) return []

      return this.$store.getters.positiveInteractionsByGroup(this.$props.resourceInteractionsGroup.id)
    },
    negativeInteractions () {
      if (!this.$props.resourceInteractionsGroup) return []

      return this.$store.getters.negativeInteractionsByGroup(this.$props.resourceInteractionsGroup.id)
    },
    neutralInteractions () {
      if (!this.$props.resourceInteractionsGroup) return []

      return this.$store.getters.neutralInteractionsByGroup(this.$props.resourceInteractionsGroup.id)
    },
  },
}
</script>
